var totalWidgetHeight = 0;
var totalWidgetWidth = 0;
var isCollapsed = true;
var topOffset = 0;
var leftOffset = 0;
var maxImageWidth = 0;
var maxImageHeight = 0;
var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

var resizeAnimation = {
	startTime:0, 
	duration:250, 
	positionFrom:0, 
	positionTo:0, 
	positionNow:0, 
	frameFrom:0, 
	frameTo:0, 
	frameNow:0, 
	timer:null, 
	element:null, 
	image:null, 
	background:null, 
	onfinished:null
};

if (window.widget){
	widget.onshow = onShow;
	widget.onhide = onHide;
	widget.onremove = onRemove;
}

function onShow(){
	loadEventsTimer();
}

function onHide(){
	
}

function onRemove(){
	cleanUP();
}

// HIDING AND SHOWING PREFERENCES

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs() {
	
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget){
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	}
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget){
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	
	}

	hideStatusText();
}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs(){
	
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget){
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	}
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	if (window.widget){
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
	}
}


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)




function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('prefsFlipper');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('prefsFlipper');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function toggleFrontNav(){
	var frontNavDiv = document.getElementById("frontNav");
	var timeNow = (new Date).getTime();
	var startingSize = parseInt(frontNavDiv.clientHeight,10);
	resizeAnimation.element = frontNavDiv;
	if (resizeAnimation.timer != null){
		clearInterval(resizeAnimation.timer);
		resizeAnimation.timer = null;
		resizeAnimation.duration -= (timeNow - resizeAnimation.startTime);
		resizeAnimation.positionFrom = resizeAnimation.positionNow;
	} else {
		resizeAnimation.duration = 250;
		resizeAnimation.positionFrom = startingSize;
	}
	var resizeTo = 500;
	totalWidgetHeight = calculateBackgroundHeight() + 43;
	if (window.widget){
		window.resizeTo (calculateBackgroundWidth(), totalWidgetHeight);
	}
	
	resizeAnimation.positionTo = parseInt(resizeTo); // lots of hard coding, yum...
	resizeAnimation.startTime = timeNow - 13; // set it back one frame.
	resizeAnimation.onfinished = animFinished;
	
	resizeAnimation.element.style.height = startingSize;
	resizeAnimation.timer = setInterval ("animate();", 13);
	animate();
}

function calculateBackgroundHeight () {
	var height = 160;
	return height;
}

function calculateBackgroundWidth () {
	var width = 344;
	return width;
}

// called before the page is loaded, get prefs, do localization, etc
function doPreloadSetup() {
	document.getElementById('frontNav').style.height = 2 + "px";
}